import { resolvedPagesVirtualModuleId } from "../app/index.js";
function* walkParentInfos(id, ctx, depth = 0, seen = /* @__PURE__ */ new Set()) {
  seen.add(id);
  const info = ctx.getModuleInfo(id);
  if (info) {
    yield [info, depth];
  }
  const importers = ((info == null ? void 0 : info.importers) || []).concat((info == null ? void 0 : info.dynamicImporters) || []);
  for (const imp of importers) {
    if (seen.has(imp)) {
      continue;
    }
    yield* walkParentInfos(imp, ctx, ++depth, seen);
  }
}
function* getTopLevelPages(id, ctx) {
  var _a;
  for (const res of walkParentInfos(id, ctx)) {
    if (((_a = res[0]) == null ? void 0 : _a.importers[0]) === resolvedPagesVirtualModuleId) {
      yield res;
    }
  }
}
export {
  getTopLevelPages,
  walkParentInfos
};
